"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const crypto_1 = __importDefault(require("crypto"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const node_fetch_1 = __importDefault(require("node-fetch"));
const path_1 = __importDefault(require("path"));
// This must be a local directory to make node module resolution possible.
const cacheDirname = path_1.default.join(__dirname, '.cache');
function createHash(data) {
    return crypto_1.default
        .createHash('md5')
        .update(data)
        .digest('hex');
}
async function writeFile(url, data) {
    /* istanbul ignore next */
    if (!(await fs_extra_1.default.pathExists(cacheDirname))) {
        await fs_extra_1.default.mkdirp(cacheDirname);
    }
    const filename = path_1.default.join(cacheDirname, `${createHash(url)}.js`);
    await fs_extra_1.default.writeFile(filename, data);
    return filename;
}
async function requireAsync(url) {
    const response = await node_fetch_1.default(url);
    const data = await response.buffer();
    const filename = await writeFile(url, data);
    return require(filename);
}
exports.loadCommonJsModule = async (url) => requireAsync(url);
//# sourceMappingURL=index.js.map